## pftools 3.2.11

=== CMakeLists.txt ===
#########################################################################################
# PfTools versioning
#
SET(VERSION "3.2.11")
SET(MAJOR_VERSION "3")
SET(MINOR_VERSION "2")
SET(PATCH_VERSION "11")
SET(DATA_PATH "share/data"     CACHE STRING "Installation data folder" )
SET(DOC_PATH  "share/doc"      CACHE STRING "Installation doc folder" )
SET(MAN1_PATH "share/man/man1" CACHE STRING "Installation man1 folder" )
SET(MAN5_PATH "share/man/man5" CACHE STRING "Installation man5 folder" )

#########################################################################################
# Header Message
#
MESSAGE(STATUS "+--------------------------------------------------------------------+")
MESSAGE(STATUS "|                          PfTools   v${VERSION}                          |")
MESSAGE(STATUS "+--------------------------------------------------------------------+")
MESSAGE(STATUS "|     (C) Copyright SIB Swiss Institute of Bioinformatics            |")
MESSAGE(STATUS "|         Thierry Schuepbach (projects@vital-it.ch)                  |")
MESSAGE(STATUS "|                                                                    |")
MESSAGE(STATUS "|     PfTools is available from                                      |")
MESSAGE(STATUS "|         https://github.com/sib-swiss/pftools3                      |")
MESSAGE(STATUS "|     under the GPL v2. See LICENSE.                                 |")
MESSAGE(STATUS "|                                                                    |")
MESSAGE(STATUS "+--------------------------------------------------------------------+")

#########################################################################################
# CMAKE
#
CMAKE_MINIMUM_REQUIRED(VERSION 3.7)
PROJECT(PFTOOLS Fortran C)
IF(COMMAND cmake_policy)
  CMAKE_POLICY(SET CMP0003 NEW)
ENDIF(COMMAND cmake_policy)
SET(CMAKE_MODULE_PATH ${PFTOOLS_SOURCE_DIR}/cmake)

#########################################################################################
# Architectures
#
INCLUDE(CMakeDetermineSystem)
#INCLUDE(CMakePrintSystemInformation)
IF(CMAKE_SYSTEM_PROCESSOR)
    MESSAGE(STATUS "Compilation on architecture ${CMAKE_SYSTEM_PROCESSOR}.")
ENDIF(CMAKE_SYSTEM_PROCESSOR)

#########################################################################################
# What type of build
#
IF(NOT CMAKE_BUILD_TYPE)
  SET(CMAKE_BUILD_TYPE Release CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)

#########################################################################################
# Determine C Compiler
#
IF(NOT CMAKE_COMPILER_IS_GNUCC)
    EXEC_PROGRAM(${CMAKE_C_COMPILER} ARGS ${CMAKE_BOOT_C_FLAGS} -E "\"${PFTOOLS_SOURCE_DIR}/cmake/CMakeTestIntel.c\"" OUTPUT_VARIABLE CMAKE_COMPILER_OUTPUT RETURN_VALUE CMAKE_COMPILER_RETURN)
    SET(CMAKE_COMPILER_IS_GNUCC_RUN 1)
    IF(NOT CMAKE_COMPILER_RETURN)
        IF("${CMAKE_COMPILER_OUTPUT}" MATCHES ".*THIS_IS_INTEL.*" )
             INCLUDE(${PFTOOLS_SOURCE_DIR}/cmake/Linux-icc.cmake)
        ENDIF("${CMAKE_COMPILER_OUTPUT}" MATCHES ".*THIS_IS_INTEL.*" )
    ENDIF(NOT CMAKE_COMPILER_RETURN)
ENDIF(NOT CMAKE_COMPILER_IS_GNUCC)

INCLUDE(CheckCCompilerFlag)
CHECK_C_COMPILER_FLAG(-msse HANDLE_SSE)
IF(HANDLE_SSE)
  SET(CMAKE_C_SSE_FLAGS "-msse")
ELSE(HANDLE_SSE)
  MESSAGE(FATAL_ERROR "C compiler does not support SSE")
ENDIF(HANDLE_SSE)
CHECK_C_COMPILER_FLAG(-msse2 HANDLE_SSE2)
IF(HANDLE_SSE2)
  SET(CMAKE_C_SSE2_FLAGS "-msse2")
ELSE(HANDLE_SSE2)
  MESSAGE(FATAL_ERROR "C compiler does not support SSE 2")
ENDIF(HANDLE_SSE2)
SET(SSE41_FLAGS "-msse4.1" "-msse41")
UNSET(CMAKE_C_SSE41_FLAGS)
FOREACH(flag IN LISTS SSE41_FLAGS)
  MESSAGE(STATUS "testing flag ${flag}...")
  CHECK_C_COMPILER_FLAG("${flag}" HANDLE_SSE41)
  IF(HANDLE_SSE41)
    SET(CMAKE_C_SSE41_FLAGS "${flag}")
    BREAK()
  ENDIF(HANDLE_SSE41)
ENDFOREACH(flag)
IF(NOT DEFINED CMAKE_C_SSE41_FLAGS)
  MESSAGE(FATAL_ERROR "C compiler does not support SSE 4.1")
ENDIF(NOT DEFINED CMAKE_C_SSE41_FLAGS)

CHECK_C_COMPILER_FLAG("-std=c99" HANDLE_C99)
IF(NOT HANDLE_C99)
  MESSAGE(FATAL_ERROR "PFTOOLS require a C compiler with C99 support")
ELSE(NOT HANDLE_C99)
  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99")
  MESSAGE(STATUS "Add -std=c99 to C compiler options")
ENDIF(NOT HANDLE_C99)

SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${CMAKE_C_SSE2_FLAGS}")
MESSAGE(STATUS "Add SSE2 to C compiler options")

IF(CMAKE_COMPILER_IS_GNUCC)
  CHECK_C_COMPILER_FLAG("-fms-extensions" MS_EXTENSION)
  IF(MS_EXTENSION)
    SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fms-extensions")
  ENDIF(MS_EXTENSION)
ENDIF(CMAKE_COMPILER_IS_GNUCC)

#########################################################################################
# Determine Fortran Compiler
#

#########################################################################################
# External Dependencies
#
SET(FIND_LIBRARY_USE_LIB64_PATHS 1)

# Check for pthread
FIND_PACKAGE(Threads REQUIRED)
IF( ${CMAKE_USE_WIN32_THREADS_INIT})
  MESSAGE(STATUS "Using Windows API for threads")
  SET(USE_WINAPI 1)
ENDIF(${CMAKE_USE_WIN32_THREADS_INIT})

#Check for presence of Perl for profile generation
FIND_PACKAGE(Perl)
IF(PERL_FOUND)
	MESSAGE(STATUS "Perl found - full test suite usable")
ELSE(PERL_FOUND)
	MESSAGE(STATUS "Perl not found - test suite only partially usable")
ENDIF(PERL_FOUND)
### insert here condition for which we do full test in case Perl is found
### or a slim version if Perl is absent

#########################################################################################
# Potentially Internal Dependencies
#
OPTION(STANDALONE "This will compile executable in static mode." OFF)
OPTION(USE_PDF "Enable output in pdf file format." OFF)
OPTION(USE_GRAPHICS "Enable graphics generation." OFF)
OPTION(USE_PCRE "Enable Perl Regex." ON)

# Check for PCRE library
IF(USE_PCRE)
	IF(STANDALONE)
		SET(BUILD_PCRE ON)
	ELSE(STANDALONE)
		OPTION(BUILD_PCRE "Build libpcre from internal source file" OFF)
		IF (NOT BUILD_PCRE)
			FIND_PACKAGE(PCRE)
			IF (NOT PCRE_FOUND)
				MESSAGE(STATUS "libpcre not found, enforcing internal version to be built...")
				SET(BUILD_PCRE ON CACHE BOOL "" FORCE)
			ENDIF(NOT PCRE_FOUND)
		ENDIF(NOT BUILD_PCRE)
	ENDIF(STANDALONE)
ENDIF(USE_PCRE)

#Check for HARU PDF library
IF(USE_PDF)
	IF(STANDALONE)
		SET(BUILD_hpdf ON)
		SET(hpdf_FOUND ON)
	ELSE(STANDALONE)
		OPTION(BUILD_hpdf "Build libHaru from internal source file" OFF)
		IF(NOT BUILD_hpdf)
			FIND_PACKAGE(hpdf)
			IF(NOT hpdf_FOUND)
				MESSAGE(STATUS "libHaru not found, enforcing internal version to be built...")
				SET(BUILD_hpdf ON CACHE BOOL "" FORCE)
				SET(hpdf_FOUND ON)
			ENDIF(NOT hpdf_FOUND)
		ELSE (NOT BUILD_hpdf)
			MESSAGE(STATUS "libHaru taken from internal source files")
		ENDIF(NOT BUILD_hpdf)
	ENDIF(STANDALONE)
ENDIF(USE_PDF)

IF(USE_GRAPHICS)
	IF(STANDALONE)
		SET(BUILD_GD ON)
		SET(BUILD_PLplot ON)
		SET(PLplot_FOUND ON)
		SET(USE_PLPLOT ON)
	ELSE(STANDALONE)
		OPTION(BUILD_GD "Build libGD from internal source file" OFF)
		#Check for GD library
		IF( NOT BUILD_GD)
			FIND_PACKAGE(GD)
			IF(GD_FOUND)
				IF(GD_SUPPORTS_PNG AND GD_SUPPORTS_JPEG)
					MESSAGE(STATUS "System GD supports PNG and JPEG")
					SET(USE_GD ON)
				ELSE(GD_SUPPORTS_PNG AND GD_SUPPORTS_JPEG)
					IF(GD_SUPPORTS_JPEG)
						MESSAGE(STATUS "System libGD does not support PNG file format")
					ELSE(GD_SUPPORTS_JPEG)
						MESSAGE(STATUS "System libGD does not supprt JPEG file format")
					ENDIF(GD_SUPPORTS_JPEG)
					MESSAGE(STATUS "libGD does not provides all features, enforcing internal version to be built...")
					SET(BUILD_GD ON)
				ENDIF(GD_SUPPORTS_PNG AND GD_SUPPORTS_JPEG)
			ELSE(GD_FOUND)
				MESSAGE(STATUS "libGD not found,  enforcing internal version to be built...")
				SET(BUILD_GD ON CACHE BOOL "" FORCE)
			ENDIF(GD_FOUND)
		ELSE( NOT BUILD_GD)
			MESSAGE(STATUS "libGD taken from internal source file")
		ENDIF( NOT BUILD_GD)

		OPTION(BUILD_PLplot "Build PLplot from internal source file" OFF)
		#Check for PLplot library and its dependency with GD
		IF(NOT BUILD_PLplot)
			FIND_PACKAGE(PLplot)
			IF(PLplot_FOUND)
				check_library_exists(
			"${PLplot_LIBRARIES}"
			"plD_dispatch_init_jpeg"
			"${PLplot_LIBRARY_DIR}"
			PLplot_SUPPORTS_JPEG
			)
				IF(PLplot_SUPPORTS_JPEG)
					SET(USE_PLPLOT ON)
					MESSAGE(STATUS "PLplot supports JPEG file format")
				ELSE(PLplot_SUPPORTS_JPEG)
					MESSAGE(STATUS "PLplot does not support JPEG file format")
					UNSET(PLplot_FOUND)
				ENDIF(PLplot_SUPPORTS_JPEG)
			ENDIF(PLplot_FOUND)
			IF(NOT PLplot_FOUND)
				MESSAGE(STATUS "PLplot not functional, enforcing internal version to be built...")
				SET(BUILD_PLplot ON CACHE BOOL "" FORCE)
				SET(PLplot_FOUND ON)
				SET(USE_PLPLOT ON)
			ENDIF(NOT PLplot_FOUND)
		ELSE(NOT BUILD_PLplot)
			MESSAGE(STATUS "PLplot not found, enforcing internal version to be built...")
		ENDIF(NOT BUILD_PLplot)
	ENDIF(STANDALONE)
ENDIF(USE_GRAPHICS)

#########################################################################################
# EXTRA HEADER FILE
#
INCLUDE (CheckIncludeFiles)
CHECK_INCLUDE_FILES (emmintrin.h HAVE_SSE2_H)
CHECK_INCLUDE_FILES (smmintrin.h HAVE_SSE_41_H)
IF (NOT HAVE_SSE2_H OR NOT HAVE_SSE_41_H)
#   MESSAGE(FATAL_ERROR "PFTOOLS require a compiler with both SSE 2 and 4.1 support")
ENDIF(NOT HAVE_SSE2_H OR NOT HAVE_SSE_41_H)

CHECK_INCLUDE_FILES (mm_malloc.h HAVE_MM_MALLOC_H)
CHECK_INCLUDE_FILES (alloca.h HAVE_ALLOCA_H)

SET(MMAP ON)
IF(MINGW)
  CHECK_INCLUDE_FILES (sys/mman.h HAVE_MMAN_H)
  IF(NOT HAVE_MMAN_H)
      MESSAGE(WARNING "MinGW package mman is missing, memory mapping cannot be used")
      SET(MMAP OFF)
  ENDIF(NOT HAVE_MMAN_H)
ENDIF(MINGW)

#########################################################################################
# Compiling options
#
# Use RPATH?
IF(CMAKE_SYSTEM_NAME STREQUAL "Darwin")
  # No rpath on Darwin. Setting it will only cause trouble.
ELSE(CMAKE_SYSTEM_NAME STREQUAL "Darwin")
  OPTION(USE_RPATH "Use -rpath when linking libraries, executables" ON)
  IF(USE_RPATH)
    SET(CMAKE_EXE_LINKER_FLAGS "-Wl,--enable-new-dtags")
    # use, i.e. don't skip the full RPATH for the build tree
    SET(CMAKE_SKIP_BUILD_RPATH  FALSE)

    # when building, don't use the install RPATH already
    # (but later on when installing)
    SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)

    # add the automatically determined parts of the RPATH
    # which point to directories outside the build tree to the install RPATH
    SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

    # the RPATH to be used when installing, but only if it's not a system directory
    LIST(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib" isSystemDir)
    IF("${isSystemDir}" STREQUAL "-1")
      SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
    ENDIF("${isSystemDir}" STREQUAL "-1")
  ENDIF(USE_RPATH)
ENDIF(CMAKE_SYSTEM_NAME STREQUAL "Darwin")

OPTION(USE_AFFINITY "CPU core affinity will be used for threads." ON)
IF(CMAKE_SYSTEM_NAME STREQUAL "Darwin")
  SET(USE_AFFINITY OFF)
ENDIF(CMAKE_SYSTEM_NAME STREQUAL "Darwin")

IF(MMAP)
  OPTION(USE_MMAP "DB files wil be mapped to memory for speed." ON)
ENDIF(MMAP)

OPTION(BUILD_SHARED_LIBS "Builds shared development library." OFF)
OPTION(BUILD_STATIC_LIBS "Builds static development library." OFF)

OPTION(USE_32BIT_INTEGER "Builds using 32bit integer format rather than 16 bits." OFF)

#########################################################################################
# CONFIGURATION FILE
#
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/src/C/config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/src/C/include/pfConfig.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/pfConfig.h)
ADD_DEFINITIONS("-I ${CMAKE_CURRENT_BINARY_DIR}/")

#########################################################################################
# STATIC BUILD
#
IF(STANDALONE)

=== drivers/CMakeLists.txt ===
# drivers/CMakeLists.txt for PLplot
###
### Process this file with cmake to produce Makefile
###
# Copyright (C) 2006-2015 Alan W. Irwin
#
# This file is part of PLplot.
#
# PLplot is free software; you can redistribute it and/or modify
# it under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; version 2 of the License.
#
# PLplot is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General Public License
# along with PLplot; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA

install(
  FILES README.drivers README.wxwidgets
  DESTINATION ${DOC_DIR}
  )

if(ENABLE_DYNDRIVERS)
  include_directories(
    ${CMAKE_SOURCE_DIR}/include
    ${CMAKE_SOURCE_DIR}/lib/qsastime
    ${CMAKE_SOURCE_DIR}/lib/nistcd
    ${CMAKE_BINARY_DIR}
    ${CMAKE_BINARY_DIR}/include
    )

  option(TEST_DYNDRIVERS "Test dynamic drivers" ON)
  if(TEST_DYNDRIVERS AND NOT CMAKE_CROSSCOMPILING)
    file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/test_dyndrivers_dir)

    set_source_files_properties(
      test-drv-info.c
      PROPERTIES COMPILE_FLAGS "-I${LTDL_INCLUDE_DIR} -DUSINGDLL"
      )
    add_executable(test-drv-info test-drv-info.c)
    target_link_libraries(test-drv-info
      plplot
      ${LTDL_LIBRARIES}
      )

    # in windows we move test-drv-info to the dll directory
    # otherwise we use the RPATH functionality
    if(USE_DLL_SUBDIRECTORY)
      set_target_properties(
	test-drv-info
	PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/dll
	)
    else(USE_DLL_SUBDIRECTORY)
      set(test-drv-info_RPATH
        ${CMAKE_CURRENT_BINARY_DIR}
        ${CMAKE_BINARY_DIR}/src
        ${CMAKE_BINARY_DIR}/lib/csa
        ${CMAKE_BINARY_DIR}/lib/nn
        ${CMAKE_BINARY_DIR}/lib/qsastime
        ${libplplot_RPATH}
        )

      set_target_properties(
        test-drv-info
        PROPERTIES
        INSTALL_RPATH "${test-drv-info_RPATH}"
        BUILD_WITH_INSTALL_RPATH ON
        )
    endif(USE_DLL_SUBDIRECTORY)
    get_target_property(test-drv-info_LOCATION test-drv-info LOCATION)
    set(test_dyndrivers_TDEPENDS test-drv-info)

  endif(TEST_DYNDRIVERS AND NOT CMAKE_CROSSCOMPILING)

  foreach(SOURCE_ROOT_NAME ${DRIVERS_LIST})
    #message("${SOURCE_ROOT_NAME}_SOURCE = ${${SOURCE_ROOT_NAME}_SOURCE}")
    if(${SOURCE_ROOT_NAME}_COMPILE_FLAGS)
      set_source_files_properties(
	${${SOURCE_ROOT_NAME}_SOURCE}
	PROPERTIES COMPILE_FLAGS "${${SOURCE_ROOT_NAME}_COMPILE_FLAGS} -DUSINGDLL"
	)
      #message("${SOURCE_ROOT_NAME}_COMPILE_FLAGS = ${${SOURCE_ROOT_NAME}_COMPILE_FLAGS}")
    else(${SOURCE_ROOT_NAME}_COMPILE_FLAGS)
      set_source_files_properties(
	${${SOURCE_ROOT_NAME}_SOURCE}
	PROPERTIES COMPILE_FLAGS "-DUSINGDLL"
	)
    endif(${SOURCE_ROOT_NAME}_COMPILE_FLAGS)

    # ${SOURCE_ROOT_NAME}_LINK_FLAGS is ideally a list of the full path names
    # to libraries determined with find_library.  However, the list can also
    # include link flags such as the -L and -l form of specifying libraries,
    # but that way of doing things only works on Unix, and even for Unix,
    # cmake does not correctly set the rpath for the build tree results
    # for non-standard locations with the -L and -l forms.
    #message("${SOURCE_ROOT_NAME}_LINK_FLAGS = ${${SOURCE_ROOT_NAME}_LINK_FLAGS}")
    # ${SOURCE_ROOT_NAME}_TARGETS is a list of PLplot CMake targets that the
    # device driver depends on.
    #message("${SOURCE_ROOT_NAME}_TARGETS = ${${SOURCE_ROOT_NAME}_TARGETS}")

    if(SOURCE_ROOT_NAME STREQUAL "qt")
      if(ANY_QT_DEVICE)
	add_library(${SOURCE_ROOT_NAME} MODULE ${${SOURCE_ROOT_NAME}_SOURCE})
	if(PLPLOT_USE_QT5)
	  # According to advice from Steve Kelly on the Cmake list, the Qt5
	  # Gui component is a dependency of the Qt5 Svg component so is not
	  # needed here, but I will leave it in since it is informative.
	  qt5_use_modules(${SOURCE_ROOT_NAME} Svg Gui PrintSupport)
	  target_link_libraries(
	    ${SOURCE_ROOT_NAME}
	    plplot
	    ${MATH_LIB}
	    ${${SOURCE_ROOT_NAME}_TARGETS}
	    )
	else(PLPLOT_USE_QT5)
	  if(NOT QT_LIBRARIES)
	    message(FATAL_ERROR "Internal build system inconsistency. QT_LIBRARIESis empty but it should be populated")
	  endif(NOT QT_LIBRARIES)
	  
	  target_link_libraries(
	    ${SOURCE_ROOT_NAME}
	    plplot
	    ${MATH_LIB}
	    ${QT_LIBRARIES}
	    ${${SOURCE_ROOT_NAME}_TARGETS}
	    )
	  # Update the target COMPILE_DEFINITIONS and INCLUDE_DIRECTORIES
	  set_qt_target_properties(${SOURCE_ROOT_NAME})
	endif(PLPLOT_USE_QT5)
	if(NOT ENABLE_qt)
	  # Note this code is never executed considering the way the
          # build system is set up now (see cmake/modules/qt.cmake),
          # but nevertheless keep it for the future in case we ever
          # want to deal with the case where we want to build the qt
          # device without building the plplotqtd library
	  add_dependencies(${SOURCE_ROOT_NAME} moc_outfile_generated)
	endif(NOT ENABLE_qt)
      else(ANY_QT_DEVICE)
	message(FATAL_ERROR "Internal build system inconsistency.  Attempt to build dynamic qt device when ANY_QT_DEVICE is false.")
      endif(ANY_QT_DEVICE)
    elseif(SOURCE_ROOT_NAME STREQUAL "wxwidgets")
      add_library(${SOURCE_ROOT_NAME} MODULE ${${SOURCE_ROOT_NAME}_SOURCE})
      target_link_libraries(
	${SOURCE_ROOT_NAME}
	plplot
	${MATH_LIB}
	${RT_LIB}
	${${SOURCE_ROOT_NAME}_LINK_FLAGS}
	${${SOURCE_ROOT_NAME}_TARGETS}
	)
    else(SOURCE_ROOT_NAME STREQUAL "qt")
      add_library(${SOURCE_ROOT_NAME} MODULE ${${SOURCE_ROOT_NAME}_SOURCE})
      target_link_libraries(
	${SOURCE_ROOT_NAME}
	plplot
	${MATH_LIB}
	${${SOURCE_ROOT_NAME}_LINK_FLAGS}
	${${SOURCE_ROOT_NAME}_TARGETS}
	)
    endif(SOURCE_ROOT_NAME STREQUAL "qt")

    # ${SOURCE_ROOT_NAME}_RPATH originally set in cmake/modules files for
    # each driver in ${DRIVERS_LIST}.  This is only used for the
    # install-tree rpath since cmake handles the build-tree rpath
    # automatically (so long as full pathnames to libraries are used).
    # Order is important here because of /usr/lib concerns.
    set(
      ${SOURCE_ROOT_NAME}_RPATH
      ${LIB_DIR}
      ${${SOURCE_ROOT_NAME}_RPATH}
      ${libplplot_RPATH}
      )
    # Our implementation of dynamic loading using libltdl assumes
    # the prefix should always be nothing (rather than lib) and the suffix
    # should be set in a platform-dependent manner in order for libltdl
    # to find the dynamic device.
    if(WIN32_OR_CYGWIN)
      # strace showed that .dll was a must for libltdl on Cygwin.
      set(DYNAMIC_SUFFIX ".dll")
    else(WIN32_OR_CYGWIN)
      # So far this works on all non-Cygwin systems, but only Linux and
      # Mac OS X have been tested so far.
      set(DYNAMIC_SUFFIX ".so")
    endif(WIN32_OR_CYGWIN)

    #message("${SOURCE_ROOT_NAME}_RPATH = ${${SOURCE_ROOT_NAME}_RPATH}")
    if(USE_RPATH)
      set_target_properties(
	${SOURCE_ROOT_NAME}
	PROPERTIES
	PREFIX ""
	SUFFIX ${DYNAMIC_SUFFIX}
	INSTALL_RPATH
	"${${SOURCE_ROOT_NAME}_RPATH}"
	)
    else(USE_RPATH)
      set_target_properties(
	${SOURCE_ROOT_NAME}
	PROPERTIES
	PREFIX ""
	SUFFIX ${DYNAMIC_SUFFIX}
	)
    endif(USE_RPATH)

    if(TEST_DYNDRIVERS AND NOT CMAKE_CROSSCOMPILING)
      get_target_property(
	${SOURCE_ROOT_NAME}_LOCATION
	${SOURCE_ROOT_NAME}
	LOCATION
	)
      add_custom_command(
	OUTPUT
	${CMAKE_CURRENT_BINARY_DIR}/test_dyndrivers_dir/${SOURCE_ROOT_NAME}.driver_info
	COMMAND test-drv-info
	${SOURCE_ROOT_NAME}
	> ${CMAKE_CURRENT_BINARY_DIR}/test_dyndrivers_dir/${SOURCE_ROOT_NAME}.driver_info
	COMMAND ${CMAKE_COMMAND} -E compare_files
	${CMAKE_CURRENT_BINARY_DIR}/test_dyndrivers_dir/${SOURCE_ROOT_NAME}.driver_info
	${CMAKE_CURRENT_BINARY_DIR}/${SOURCE_ROOT_NAME}.driver_info
	DEPENDS
	${${SOURCE_ROOT_NAME}_LOCATION}
	${test-drv-info_LOCATION}
	)
      add_custom_target(test_${SOURCE_ROOT_NAME}_dyndriver
	DEPENDS
	${CMAKE_CURRENT_BINARY_DIR}/test_dyndrivers_dir/${SOURCE_ROOT_NAME}.driver_info
	)
      set_property(GLOBAL
	PROPERTY FILE_DEPENDS_${SOURCE_ROOT_NAME}_dyndriver
	${CMAKE_CURRENT_BINARY_DIR}/test_dyndrivers_dir/${SOURCE_ROOT_NAME}.driver_info
	)
      add_dependencies(test_${SOURCE_ROOT_NAME}_dyndriver
	test-drv-info
	${SOURCE_ROOT_NAME}
	)
      list(APPEND test_dyndrivers_TDEPENDS test_${SOURCE_ROOT_NAME}_dyndriver)
    endif(TEST_DYNDRIVERS AND NOT CMAKE_CROSSCOMPILING)

    install(TARGETS ${SOURCE_ROOT_NAME}
      EXPORT export_plplot
      DESTINATION ${DRV_DIR}
      )
    install(
      FILES ${CMAKE_CURRENT_BINARY_DIR}/${SOURCE_ROOT_NAME}.driver_info
      DESTINATION ${DRV_DIR}
      )
  endforeach(SOURCE_ROOT_NAME ${DRIVERS_LIST})

  # The tk device driver depends internally on the xwin device driver.
  # Therefore make target tk depend on target xwin so
  # xwin will always be built first.
  if(TARGET tk)
    if(TARGET xwin)
      add_dependencies(tk xwin)
    else(TARGET xwin)
      message(FATAL_ERROR "Internal build system inconsistency where the tk target but not the xwin target are configured.")
    endif(TARGET xwin)
  endif(TARGET tk)

  if(PLD_tkwin AND USE_TCL_TK_STUBS)
    set_target_properties(
      tkwin
      PROPERTIES COMPILE_DEFINITIONS "USE_TCL_STUBS;USE_TK_STUBS"
      )
  endif(PLD_tkwin AND USE_TCL_TK_STUBS)

  if(TEST_DYNDRIVERS AND NOT CMAKE_CROSSCOMPILING)
    add_custom_target(test_dyndrivers ALL
      )
    add_dependencies(test_dyndrivers ${test_dyndrivers_TDEPENDS})
  endif(TEST_DYNDRIVERS AND NOT CMAKE_CROSSCOMPILING)

endif(ENABLE_DYNDRIVERS)

=== tests/CMakeLists.txt ===
IF (NOT EXISTS "${TESTS_DIRECTORY}/examples")
	FILE(MAKE_DIRECTORY "${TESTS_DIRECTORY}/examples")
ENDIF (NOT EXISTS "${TESTS_DIRECTORY}/examples")
SET(EXAMPLES_TMP_DIR "${TESTS_DIRECTORY}/examples")
SET(EXAMPLES_DATA_DIR "${TESTS_DATA_DIR}/examples")
SET(PERL_SCRIPT_DIR "${PROJECT_SOURCE_DIR}/src/Perl")


FILE(GLOB EXAMPLES_FILES examples/*)

FILE(COPY ${EXAMPLES_FILES} DESTINATION ${TESTS_DIRECTORY}/examples/)

CONFIGURE_FILE(${TESTS_DIRECTORY}/examples/test_V2.sh.cmake
               ${TESTS_DIRECTORY}/examples/test_V2.sh.tmp @ONLY)
FILE(GENERATE OUTPUT ${TESTS_DIRECTORY}/examples/test_V2.sh
              INPUT ${TESTS_DIRECTORY}/examples/test_V2.sh.tmp)
FILE(REMOVE ${TESTS_DIRECTORY}/examples/test_V2.sh.cmake)


CONFIGURE_FILE(${TESTS_DIRECTORY}/examples/test_V3.sh.cmake
               ${TESTS_DIRECTORY}/examples/test_V3.sh.tmp @ONLY)
FILE(GENERATE OUTPUT ${TESTS_DIRECTORY}/examples/test_V3.sh
              INPUT ${TESTS_DIRECTORY}/examples/test_V3.sh.tmp)
FILE(REMOVE ${TESTS_DIRECTORY}/examples/test_V3.sh.cmake)

CONFIGURE_FILE(${TESTS_DIRECTORY}/examples/test_V3_output.sh.cmake
               ${TESTS_DIRECTORY}/examples/test_V3_output.sh.tmp @ONLY)
FILE(GENERATE OUTPUT ${TESTS_DIRECTORY}/examples/test_V3_output.sh
              INPUT ${TESTS_DIRECTORY}/examples/test_V3_output.sh.tmp)
FILE(REMOVE ${TESTS_DIRECTORY}/examples/test_V3_output.sh.cmake)

CONFIGURE_FILE(${TESTS_DIRECTORY}/examples/test_pfsearchV3_iupac.pl.cmake
               ${TESTS_DIRECTORY}/examples/test_pfsearchV3_iupac.pl.tmp @ONLY)
FILE(GENERATE OUTPUT ${TESTS_DIRECTORY}/examples/test_pfsearchV3_iupac.pl
              INPUT ${TESTS_DIRECTORY}/examples/test_pfsearchV3_iupac.pl.tmp)
FILE(REMOVE ${TESTS_DIRECTORY}/examples/test_pfsearchV3_iupac.pl.cmake)

CONFIGURE_FILE(${TESTS_DIRECTORY}/examples/test_scan_search.pl.cmake
               ${TESTS_DIRECTORY}/examples/test_scan_search.pl.tmp @ONLY)
FILE(GENERATE OUTPUT ${TESTS_DIRECTORY}/examples/test_scan_search.pl
              INPUT ${TESTS_DIRECTORY}/examples/test_scan_search.pl.tmp)
FILE(REMOVE ${TESTS_DIRECTORY}/examples/test_scan_search.pl.cmake)


INSTALL(DIRECTORY examples/
        DESTINATION share/examples
        PATTERN "CMakeLists.txt" EXCLUDE
)
INSTALL(CODE "EXECUTE_PROCESS(COMMAND find ${CMAKE_INSTALL_PREFIX}/share/examples/ -type f -name \*.cmake -exec chmod a+rx {} \;)")
INSTALL(CODE "EXECUTE_PROCESS(COMMAND find ${CMAKE_INSTALL_PREFIX}/share/examples/ -type f -name \*.cmake -exec sed -i \"s|@DATA_DIR@/Matrices|${CMAKE_INSTALL_PREFIX}/share/data/cmp|; s|@PERL_SCRIPT_DIR@|${CMAKE_INSTALL_PREFIX}/bin|\" {} \;)")
INSTALL(CODE "EXECUTE_PROCESS(COMMAND find ${CMAKE_INSTALL_PREFIX}/share/examples/ -type f -name \*.cmake -exec perl -i -pe \"s|.<TARGET_FILE:(.+?)>|${CMAKE_INSTALL_PREFIX}/bin/$1|\" {} \;)")
INSTALL(CODE "FILE(RENAME ${CMAKE_INSTALL_PREFIX}/share/examples/test_V2.sh.cmake               ${CMAKE_INSTALL_PREFIX}/share/examples/test_V2.sh)")
INSTALL(CODE "FILE(RENAME ${CMAKE_INSTALL_PREFIX}/share/examples/test_V3.sh.cmake               ${CMAKE_INSTALL_PREFIX}/share/examples/test_V3.sh)")
INSTALL(CODE "FILE(RENAME ${CMAKE_INSTALL_PREFIX}/share/examples/test_scan_search.pl.cmake      ${CMAKE_INSTALL_PREFIX}/share/examples/test_scan_search.pl)")
INSTALL(CODE "FILE(RENAME ${CMAKE_INSTALL_PREFIX}/share/examples/test_pfsearchV3_iupac.pl.cmake ${CMAKE_INSTALL_PREFIX}/share/examples/test_pfsearchV3_iupac.pl)")

=== bindings/tcl/CMakeLists.txt ===
# bindings/tcl/CMakeLists.txt
### Process this file with cmake to produce Makefile
###
# Copyright (C) 2006-2015 Alan W. Irwin
#
# This file is part of PLplot.
#
# PLplot is free software; you can redistribute it and/or modify
# it under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; version 2 of the License.
#
# PLplot is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General Public License
# along with PLplot; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA

if(ENABLE_tcl)

  # Check consistency of plplot_parameters.h.
  add_custom_target(
    check_tcl_parameters
    ${CMAKE_COMMAND} -E echo "Check that bindings/tcl/plplot_parameters.h is consistent with the #defines in bindings/swig-support/plplotcapi.i"
    COMMAND ${CMAKE_COMMAND} -E remove -f
    ${CMAKE_CURRENT_BINARY_DIR}/plplot_parameters.h_compare
    COMMAND
    sed -f ${CMAKE_CURRENT_SOURCE_DIR}/global_defines.sed <
    ${CMAKE_SOURCE_DIR}/bindings/swig-support/plplotcapi.i >
    ${CMAKE_CURRENT_BINARY_DIR}/plplot_parameters.h_compare
    COMMAND
    COMMAND
    cmp ${CMAKE_CURRENT_SOURCE_DIR}/plplot_parameters.h
    ${CMAKE_CURRENT_BINARY_DIR}/plplot_parameters.h_compare
    )

  add_dependencies(check_all check_tcl_parameters)

  # tclmatrix
  set(tclmatrix_LIB_SRCS
    tclMatrix.c
    matrixInit.c
    )

  include_directories(
    ${TCL_INCLUDE_PATH}
    ${CMAKE_SOURCE_DIR}/include
    ${CMAKE_SOURCE_DIR}/lib/qsastime
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_BINARY_DIR}
    ${CMAKE_BINARY_DIR}/include
    )

  set(
    libplplottcltk_COMPILE_FLAGS
    "-I\"${TCL_INCLUDE_PATH}\""
    )

  if(BUILD_SHARED_LIBS)
    set_source_files_properties(${tclmatrix_LIB_SRCS}
      PROPERTIES COMPILE_FLAGS "-DUSINGDLL" )
  endif(BUILD_SHARED_LIBS)

  add_library(tclmatrix ${tclmatrix_LIB_SRCS})

  if(USE_TCL_TK_STUBS)
    target_link_libraries(tclmatrix ${TCL_STUB_LIBRARY})
    set_target_properties(
      tclmatrix
      PROPERTIES COMPILE_DEFINITIONS USE_TCL_STUBS
      )
  else(USE_TCL_TK_STUBS)
    target_link_libraries(tclmatrix ${TCL_LIBRARY})
  endif(USE_TCL_TK_STUBS)

  if(USE_RPATH)
    set(LIB_INSTALL_RPATH ${LIB_DIR} ${TCL_RPATH})
    filter_rpath(LIB_INSTALL_RPATH)
    set_target_properties(tclmatrix
      PROPERTIES
      SOVERSION ${tclmatrix_SOVERSION}
      VERSION ${tclmatrix_VERSION}
      INSTALL_RPATH "${LIB_INSTALL_RPATH}"
      INSTALL_NAME_DIR "${LIB_DIR}"
      )
  else(USE_RPATH)
    set_target_properties(tclmatrix
      PROPERTIES
      SOVERSION ${tclmatrix_SOVERSION}
      VERSION ${tclmatrix_VERSION}
      INSTALL_NAME_DIR "${LIB_DIR}"
      )
  endif(USE_RPATH)

  install(TARGETS tclmatrix
    EXPORT export_plplot
    ARCHIVE DESTINATION ${LIB_DIR}
    LIBRARY DESTINATION ${LIB_DIR}
    RUNTIME DESTINATION ${BIN_DIR}
    )

  set(tclmatrix_INSTALLED_HEADERS
    tclMatrix.h
    )

  install(
    FILES ${tclmatrix_INSTALLED_HEADERS}
    DESTINATION ${INCLUDE_DIR}
    )
  # end tclmatrix

  # plplottcltk
  set(
    tclgenfiles
    ${CMAKE_CURRENT_BINARY_DIR}/tclgen.h
    ${CMAKE_CURRENT_BINARY_DIR}/tclgen_s.h
    ${CMAKE_CURRENT_BINARY_DIR}/tclgen.c
    )

  add_custom_command(
    OUTPUT ${tclgenfiles}
    COMMAND ${TCL_TCLSH}
    ${CMAKE_CURRENT_SOURCE_DIR}/pltclgen.tcl ${CMAKE_CURRENT_SOURCE_DIR}
    DEPENDS
    ${CMAKE_CURRENT_SOURCE_DIR}/pltclgen.tcl
    ${CMAKE_CURRENT_SOURCE_DIR}/plapi.tpl
    ${CMAKE_CURRENT_SOURCE_DIR}/tclcmd.tpl
    )

  include_directories(${CMAKE_CURRENT_BINARY_DIR})
  set_source_files_properties(
    tclAPI.c
    PROPERTIES OBJECT_DEPENDS "${tclgenfiles}"
    )

  set(plplottcltk_LIB_SRCS
    tclAPI.c
    )

  set(plplottcltk_Main_LIB_SRCS
    tclMain.c
    )

  if(BUILD_SHARED_LIBS)
    set_source_files_properties(${plplottcltk_LIB_SRCS}
      PROPERTIES COMPILE_FLAGS "-DUSINGDLL"
      )
    set_source_files_properties(${plplottcltk_Main_LIB_SRCS}
      PROPERTIES COMPILE_FLAGS "-DUSINGDLL"
      )
  endif(BUILD_SHARED_LIBS)

  if(USE_TCL_TK_STUBS)
    set(
      plplottcltk_link_libraries
      tclmatrix
      plplot
      ${TCL_STUB_LIBRARY}
      )
    set(
      libplplottcltk_LINK_FLAGS
      -ltclmatrix
      ${TCL_STUB_LIBRARY}
      )
  else(USE_TCL_TK_STUBS)
    set(
      plplottcltk_link_libraries
      tclmatrix
      plplot
      ${TCL_LIBRARY}
      )
    set(
      libplplottcltk_LINK_FLAGS
      -ltclmatrix
      ${TCL_LIBRARY}
      )
  endif(USE_TCL_TK_STUBS)

  set(
    plplottcltk_Main_link_libraries
    plplot
    ${TCL_LIBRARY}
    )
  set(
    libplplottcltk_Main_LINK_FLAGS
     ${TCL_LIBRARY}
    )

  message(STATUS "ENABLE_itcl: ${ENABLE_itcl}")
  if(ENABLE_itcl)
    include_directories(${ITCL_INCLUDE_PATH})

    # tkMain.c is the only code that currently has a dependence on
    # itcl library routines.  Since that code is now part of the source code
    # for libplplottcltk_Main, only flags for that library (but not
    # libplplottcltk any more) are modified below.

    set(
      libplplottcltk_Main_COMPILE_FLAGS
      "${libplplottcltk_Main_COMPILE_FLAGS} -I\"${ITCL_INCLUDE_PATH}\""
      )
    set(plplottcltk_Main_link_libraries
      ${plplottcltk_Main_link_libraries}
      ${ITCL_LIBRARY}
      )
    set(
      libplplottcltk_Main_LINK_FLAGS
      ${libplplottcltk_Main_LINK_FLAGS}
      ${ITCL_LIBRARY}
      )
  endif(ENABLE_itcl)
  message(STATUS "Itcl libraries: ${plplottcltk_Main_link_libraries}")

  if(ENABLE_tkX)
    set(plplottcltk_LIB_SRCS
      ${plplottcltk_LIB_SRCS}
      ${CMAKE_SOURCE_DIR}/bindings/tk/Pltk_Init.c
      ${CMAKE_SOURCE_DIR}/bindings/tk/plframe.c
      ${CMAKE_SOURCE_DIR}/bindings/tk/plr.c
      ${CMAKE_SOURCE_DIR}/bindings/tk/tcpip.c
      )

    set(plplottcltk_Main_LIB_SRCS
      ${plplottcltk_Main_LIB_SRCS}
      ${CMAKE_SOURCE_DIR}/bindings/tk/tkMain.c
      )

    include_directories(${TK_INCLUDE_PATH})
    # Transform TK_INCLUDE_PATH (which is a list) to blank-delimited flag form.
    string(REGEX REPLACE ";" "\" -I\"" TKLIB_COMPILE_FLAGS "-I\"${TK_INCLUDE_PATH}\"")
    set(
      libplplottcltk_COMPILE_FLAGS
      "${libplplottcltk_COMPILE_FLAGS} ${TKLIB_COMPILE_FLAGS}"
      )

    set(
      libplplottcltk_Main_COMPILE_FLAGS
      "${libplplottcltk_Main_COMPILE_FLAGS} ${TKLIB_COMPILE_FLAGS}"
      )

    if(BUILD_SHARED_LIBS)
      set_source_files_properties(${plplottcltk_LIB_SRCS}
	PROPERTIES COMPILE_FLAGS "-DUSINGDLL"
	)
      set_source_files_properties(${plplottcltk_Main_LIB_SRCS}
	PROPERTIES COMPILE_FLAGS "-DUSINGDLL"
	)
    endif(BUILD_SHARED_LIBS)

    if(USE_TCL_TK_STUBS)
      set(plplottcltk_link_libraries
	${plplottcltk_link_libraries}
	${TK_STUB_LIBRARY}
	${X11_X11_LIB}
	)
      set(
	libplplottcltk_LINK_FLAGS
	${libplplottcltk_LINK_FLAGS}
	${TK_STUB_LIBRARY}
	)
    else(USE_TCL_TK_STUBS)
      set(plplottcltk_link_libraries
	${plplottcltk_link_libraries}
	${TK_LIBRARY}
	${X11_X11_LIB}
	)
      set(
	libplplottcltk_LINK_FLAGS
	${libplplottcltk_LINK_FLAGS}
	${TK_LIBRARY}
	)
    endif(USE_TCL_TK_STUBS)

    set(plplottcltk_Main_link_libraries
      ${plplottcltk_Main_link_libraries}
      ${TK_LIBRARY}
      ${X11_X11_LIB}
      )
    set(
      libplplottcltk_Main_LINK_FLAGS
      ${libplplottcltk_Main_LINK_FLAGS}
      ${TK_LIBRARY}
      )

    if(ENABLE_itkX)
      include_directories(${ITK_INCLUDE_PATH})
      # tkMain.c is the only code that currently has a dependence on
      # itk library routines.  Since that code is now part of the source code
      # for libplplottcltk_Main, only flags for that library (but not
      # libplplottcltk any more) are modified below.

      set(
	libplplottcltk_Main_COMPILE_FLAGS
	"${libplplottcltk_Main_COMPILE_FLAGS} -I\"${ITK_INCLUDE_PATH}\""
	)
      set(plplottcltk_Main_link_libraries
	${plplottcltk_Main_link_libraries}
	${ITK_LIBRARY}
	)
      set(
	libplplottcltk_Main_LINK_FLAGS
	${libplplottcltk_Main_LINK_FLAGS}
	${ITK_LIBRARY}
	)
    endif(ENABLE_itkX)
  endif(ENABLE_tkX)

  add_library(plplottcltk ${plplottcltk_LIB_SRCS})
  add_library(plplottcltk_Main ${plplottcltk_Main_LIB_SRCS})

  if(USE_TCL_TK_STUBS)
    if(ENABLE_tkX)
      set_target_properties(
	plplottcltk
	PROPERTIES COMPILE_DEFINITIONS "USE_TCL_STUBS;USE_TK_STUBS"
	)
    else(ENABLE_tkX)
      set_target_properties(
	plplottcltk
	PROPERTIES COMPILE_DEFINITIONS USE_TCL_STUBS
	)
    endif(ENABLE_tkX)
  endif(USE_TCL_TK_STUBS)

  if(NON_TRANSITIVE)
    # empty list ==> non-transitive linking for everything that links to
    # libtclmatrixd and libplplottcltkd in the shared libraries case.
    target_link_libraries(tclmatrix LINK_INTERFACE_LIBRARIES)
    target_link_libraries(plplottcltk LINK_INTERFACE_LIBRARIES)
    target_link_libraries(plplottcltk_Main LINK_INTERFACE_LIBRARIES)
  endif(NON_TRANSITIVE)

  #message(STATUS
  #"plplottcltk_link_libraries =
  #${plplottcltk_link_libraries}"
  #)
  target_link_libraries(
    plplottcltk
    ${plplottcltk_link_libraries}
    )

  target_link_libraries(
    plplottcltk_Main
    ${plplottcltk_Main_link_libraries}
    )

  if(USE_RPATH)
    get_target_property(LIB_INSTALL_RPATH plplot INSTALL_RPATH)
    list(APPEND LIB_INSTALL_RPATH ${TCL_TK_RPATH})
    filter_rpath(LIB_INSTALL_RPATH)
    set_target_properties(plplottcltk
      PROPERTIES
      SOVERSION ${plplottcltk_SOVERSION}
      VERSION ${plplottcltk_VERSION}
      INSTALL_RPATH "${LIB_INSTALL_RPATH}"
      INSTALL_NAME_DIR "${LIB_DIR}"
      )

    # This version of LIB_INSTALL_RPATH also used below for pltcl.
    list(APPEND LIB_INSTALL_RPATH ${TCL_TK_ITCL_ITK_RPATH})
    filter_rpath(LIB_INSTALL_RPATH)
    set_target_properties(plplottcltk_Main
      PROPERTIES
      SOVERSION ${plplottcltk_Main_SOVERSION}
      VERSION ${plplottcltk_Main_VERSION}
      INSTALL_RPATH "${LIB_INSTALL_RPATH}"
      INSTALL_NAME_DIR "${LIB_DIR}"
      )
  else(USE_RPATH)
    set_target_properties(plplottcltk
      PROPERTIES
      SOVERSION ${plplottcltk_SOVERSION}
      VERSION ${plplottcltk_VERSION}
      INSTALL_NAME_DIR "${LIB_DIR}"
      )

    set_target_properties(plplottcltk_Main
      PROPERTIES
      SOVERSION ${plplottcltk_Main_SOVERSION}
      VERSION ${plplottcltk_Main_VERSION}
      INSTALL_NAME_DIR "${LIB_DIR}"
      )

  endif(USE_RPATH)

  install(TARGETS plplottcltk
    EXPORT export_plplot
    ARCHIVE DESTINATION ${LIB_DIR}
    LIBRARY DESTINATION ${LIB_DIR}
    RUNTIME DESTINATION ${BIN_DIR}
    )

  install(TARGETS plplottcltk_Main
    EXPORT export_plplot
    ARCHIVE DESTINATION ${LIB_DIR}
    LIBRARY DESTINATION ${LIB_DIR}
    RUNTIME DESTINATION ${BIN_DIR}
    )

  set(plplottcltk_INSTALLED_HEADERS
    pltcl.h
    )

  install(
    FILES ${plplottcltk_INSTALLED_HEADERS}
    DESTINATION ${INCLUDE_DIR}
    )

  # end plplottcltk

  # Generate plplot.tcl and tclIndex in build tree.  At least the first one
  # is always needed for build-tree tests of tcl examples.

  add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/plplot.tcl
    COMMAND ${CMAKE_COMMAND} -E copy_if_different
    ${CMAKE_SOURCE_DIR}/bindings/tk/plplot.tcl
    ${CMAKE_CURRENT_BINARY_DIR}/plplot.tcl
    DEPENDS
    ${CMAKE_SOURCE_DIR}/bindings/tk/plplot.tcl
    )

  # _target suffix to avoid nameclash with filename plplot.tcl.  This
  # nameclash screwed up ../tk/configuration which had a non-generated file
  # of the same name which was a dependency of a custom target.
  add_custom_target(plplot.tcl_target ALL
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/plplot.tcl
    )
  set_property(GLOBAL PROPERTY
    FILES_plplot.tcl_target ${CMAKE_CURRENT_BINARY_DIR}/plplot.tcl
    )

  # A Tcl expert should insert the file depends here.
  add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/tclIndex

=== examples/c++/CMakeLists.txt ===
# examples/c++/CMakeLists.txt
### Process this file with cmake to produce Makefile
###
# Copyright (C) 2006 Andrew Ross
# Copyright (C) 2006-2015 Alan W. Irwin
#
# This file is part of PLplot.
#
# PLplot is free software; you can redistribute it and/or modify
# it under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; version 2 of the License.
#
# PLplot is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General Public License
# along with PLplot; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA

# N.B. This file is used for both the core build (which installs the examples
# and optionally [depending on BUILD_TEST} builds them) and the installed
# examples build.  The core build has BUILD_TEST OFF or ON at user option
# and CORE_BUILD always ON.  The installed examples build always has
# BUILD_TEST ON and CORE_BUILD OFF.

set(cxx_STRING_INDICES
  "01cc"
  "00"
  "01"
  "02"
  "03"
  "04"
  "05"
  "06"
  "07"
  "08"
  "09"
  "10"
  "11"
  "12"
  "13"
  "14"
  "15"
  "16"
  "17"
  "18"
  "19"
  "20"
  "21"
  "22"
  "23"
  "24"
  "25"
  "26"
  "27"
  "28"
  "29"
  "30"
  "31"
  "33"
  )

if(ENABLE_wxwidgets)
  if(OLD_WXWIDGETS)
    set(wxPLplotDemo_SRCS deprecated_wxPLplotDemo.cpp)
  else(OLD_WXWIDGETS)
    set(wxPLplotDemo_SRCS wxPLplotDemo.cpp)
  endif(OLD_WXWIDGETS)
endif(ENABLE_wxwidgets)

if(CORE_BUILD)
  set(cxx_SRCS plc++demos.h)
  foreach(STRING_INDEX ${cxx_STRING_INDICES})
    set(cxx_SRCS ${cxx_SRCS} x${STRING_INDEX}.cc)
  endforeach(STRING_INDEX ${cxx_STRING_INDICES})

  if(PLD_extqt)
    set(qt_INSTALLED_FILES qt_PlotWindow.cpp qt_PlotWindow.h qt_example.cpp README.qt_example)
  endif(PLD_extqt)

  install(FILES ${cxx_SRCS} ${wxPLplotDemo_SRCS} ${qt_INSTALLED_FILES} DESTINATION ${DATA_DIR}/examples/c++)

  set(CXX ${CMAKE_CXX_COMPILER})
  configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/Makefile.examples.in
    ${CMAKE_CURRENT_BINARY_DIR}/Makefile.examples
    )

  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/Makefile.examples 
    DESTINATION ${DATA_DIR}/examples/c++
    RENAME Makefile
    )

  install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/CMakeLists.txt
    DESTINATION ${DATA_DIR}/examples/c++
    )
endif(CORE_BUILD)

if(BUILD_TEST)
  if(CORE_BUILD)
    include_directories(
      ${CMAKE_SOURCE_DIR}/bindings/c++
      ${CMAKE_SOURCE_DIR}/include
      ${CMAKE_BINARY_DIR}/include
      ${CMAKE_SOURCE_DIR}/lib/qsastime
      )
  else(CORE_BUILD)
    include_directories(${INCLUDE_DIR})
  endif(CORE_BUILD)
endif(BUILD_TEST)

if(BUILD_TEST)
  set_property(GLOBAL PROPERTY TARGETS_examples_cxx)
  foreach(STRING_INDEX ${cxx_STRING_INDICES})
    if(BUILD_SHARED_LIBS)
      set_source_files_properties(x${STRING_INDEX}.cc
        PROPERTIES COMPILE_FLAGS "-DUSINGDLL")
    endif(BUILD_SHARED_LIBS)
    add_executable(x${STRING_INDEX} x${STRING_INDEX}.cc)
    target_link_libraries(x${STRING_INDEX} plplotcxx ${MATH_LIB})
    set_property(GLOBAL APPEND PROPERTY TARGETS_examples_cxx x${STRING_INDEX})
  endforeach(STRING_INDEX ${cxx_STRING_INDICES})

  if(ENABLE_wxwidgets)
    # Build wxwidgets applications with same wxwidgets compile and link flags
    # as used with the PLplot wxwidgets device driver.
    if(CORE_BUILD)
      include_directories(
	${CMAKE_SOURCE_DIR}/bindings/wxwidgets
	${CMAKE_BINARY_DIR}/bindings/wxwidgets
	)
    endif(CORE_BUILD)
    if(BUILD_SHARED_LIBS)
      set_source_files_properties(${wxPLplotDemo_SRCS}
        PROPERTIES COMPILE_FLAGS "-DUSINGDLL ${wxwidgets_COMPILE_FLAGS}")
    else(BUILD_SHARED_LIBS)
      set_source_files_properties(${wxPLplotDemo_SRCS}
        PROPERTIES COMPILE_FLAGS "${wxwidgets_COMPILE_FLAGS}")
    endif(BUILD_SHARED_LIBS)
    add_executable(wxPLplotDemo WIN32 ${wxPLplotDemo_SRCS})
    target_link_libraries(wxPLplotDemo plplotwxwidgets plplotcxx ${wxwidgets_LINK_FLAGS} ${MATH_LIB})
  endif(ENABLE_wxwidgets)

  if(ENABLE_qt)
    if(CORE_BUILD)
      set(BUILD_qt_example ON)
      if(NOT PLPLOT_USE_QT5 AND NOT QT_LIBRARIES)
        message(FATAL_ERROR "include(${QT_USE_FILE}) failed in core build examples/c++ subdirectory.")
      endif(NOT PLPLOT_USE_QT5 AND NOT QT_LIBRARIES)
    else(CORE_BUILD)
      if(PLPLOT_USE_QT5)
	# qt_example build linking taken care of automatically by importing
	# the plplotqt library.
	set(BUILD_qt_example ON)
      else(PLPLOT_USE_QT5)
	# Must find Qt4 all over again here rather than simply copying variables
	# from the core build to this installed examples build so that we can
	# access the qt4_wrap_cpp macro here.
	find_package(Qt4 4.8.2 REQUIRED QtCore QtGui QtSvg)
	# To avoid Qt4 version mismatch make sure the Qt version matches that
	# used by the core build.
	if(QT4_FOUND AND QT_VERSION_MAJOR STREQUAL "${CORE_QT_VERSION_MAJOR}" AND QT_VERSION_MINOR STREQUAL "${CORE_QT_VERSION_MINOR}" AND QT_VERSION_PATCH STREQUAL "${CORE_QT_VERSION_PATCH}")
	  include(ndp_UseQt4)
	  if(NOT QT_LIBRARIES)
            message(FATAL_ERROR "include(${QT_USE_FILE}) failed in installed examples build examples/c++ subdirectory.")
	  endif(NOT QT_LIBRARIES)
	  set(BUILD_qt_example ON)
	else(QT4_FOUND AND QT_VERSION_MAJOR STREQUAL "${CORE_QT_VERSION_MAJOR}" AND QT_VERSION_MINOR STREQUAL "${CORE_QT_VERSION_MINOR}" AND QT_VERSION_PATCH STREQUAL "${CORE_QT_VERSION_PATCH}")
	  message(STATUS "WARNING: Qt4 not found or wrong version.  qt_example not built")
	  set(BUILD_qt_example OFF)
	endif(QT4_FOUND AND QT_VERSION_MAJOR STREQUAL "${CORE_QT_VERSION_MAJOR}" AND QT_VERSION_MINOR STREQUAL "${CORE_QT_VERSION_MINOR}" AND QT_VERSION_PATCH STREQUAL "${CORE_QT_VERSION_PATCH}")
      endif(PLPLOT_USE_QT5)
    endif(CORE_BUILD)
    if(BUILD_qt_example)
      if(PLPLOT_USE_QT5)
	qt5_wrap_cpp(
	  QT_MOC_OUTFILES
	  ${CMAKE_CURRENT_SOURCE_DIR}/qt_PlotWindow.h
	  )
	set_source_files_properties(
	  ${QT_MOC_OUTFILES}
	  PROPERTIES GENERATED "ON"
	  )
	if(BUILD_SHARED_LIBS)
	  set_source_files_properties(qt_example.cpp qt_PlotWindow.cpp ${QT_MOC_OUTFILES}
            PROPERTIES COMPILE_FLAGS "-DUSINGDLL")
	endif(BUILD_SHARED_LIBS)
	add_executable(qt_example qt_example.cpp qt_PlotWindow.cpp ${QT_MOC_OUTFILES})
	qt5_use_modules(qt_example Svg Gui PrintSupport)
	if(ENABLE_DYNDRIVERS)
	  target_link_libraries(qt_example ${QT_LIBRARIES} plplotqt plplot ${qt_example_TARGETS})
	else(ENABLE_DYNDRIVERS)
	  # In this case plplot contains all the code in plplotqt so there is no
          # need to link to plplotqt at all, and in fact for some reason it
          # causes memory management issues to link to both plplot and plplotqt in this case.
	  target_link_libraries(qt_example ${QT_LIBRARIES} plplot ${qt_example_TARGETS})
	endif(ENABLE_DYNDRIVERS)
      else(PLPLOT_USE_QT5)
	qt4_wrap_cpp(
	  QT_MOC_OUTFILES
	  ${CMAKE_CURRENT_SOURCE_DIR}/qt_PlotWindow.h
	  )
	# message("QT_MOC_OUTFILES = ${QT_MOC_OUTFILES}")
	set_source_files_properties(
	  ${QT_MOC_OUTFILES}
	  PROPERTIES GENERATED "ON"
	  )
	if(BUILD_SHARED_LIBS)
	  set_source_files_properties(qt_example.cpp qt_PlotWindow.cpp ${QT_MOC_OUTFILES}
            PROPERTIES COMPILE_FLAGS "-DUSINGDLL")
	endif(BUILD_SHARED_LIBS)
	add_executable(qt_example qt_example.cpp qt_PlotWindow.cpp ${QT_MOC_OUTFILES})
	if(ENABLE_DYNDRIVERS)
	  target_link_libraries(qt_example ${QT_LIBRARIES} plplotqt plplot)
	else(ENABLE_DYNDRIVERS)
	  # In this case plplot contains all the code in plplotqt so there is no
          # need to link to plplotqt at all, and in fact for some reason it
          # causes memory management issues to link to both plplot and plplotqt in this case.
	  target_link_libraries(qt_example ${QT_LIBRARIES} plplot)
	endif(ENABLE_DYNDRIVERS)
	# Update the target COMPILE_DEFINITIONS and INCLUDE_DIRECTORIES
	set_qt_target_properties(qt_example)
      endif(PLPLOT_USE_QT5)
    endif(BUILD_qt_example)
  endif(ENABLE_qt)
endif(BUILD_TEST)

=== examples/octave/CMakeLists.txt ===
# examples/octave/CMakeLists.txt for PLplot
###
### Process this file with cmake to produce Makefile
###
# Copyright (C) 2006 Alan W. Irwin
#
# This file is part of PLplot.
#
# PLplot is free software; you can redistribute it and/or modify
# it under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; version 2 of the License.
#
# PLplot is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General Public License
# along with PLplot; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA

# N.B. This file is used for both the core build (which installs the examples
# and optionally [depending on BUILD_TEST} builds them) and the installed
# examples build.  The core build has BUILD_TEST OFF or ON at user option
# and CORE_BUILD always ON.  The installed examples build always has
# BUILD_TEST ON and CORE_BUILD OFF.

set(examples_octave
  p1.m
  p2.m
  p3.m
  p4.m
  p5.m
  p6.m
  p7.m
  p8.m
  p9.m
  p10.m
  p11.m
  p12.m
  p13.m
  p14.m
  p15.m
  p16.m
  p17.m
  p18.m
  p19.m
  p20.m
  p21.m
  x00c.m
  x01c.m
  x02c.m
  x03c.m
  x04c.m
  x05c.m
  x06c.m
  x07c.m
  x08c.m
  x09c.m
  x10c.m
  x11c.m
  x12c.m
  x13c.m
  x14c.m
  x15c.m
  x16c.m
  x17c.m
  x18c.m
  x19c.m
  x20c.m
  x21c.m
  x22c.m
  x23c.m
  x24c.m
  x25c.m
  x26c.m
  x27c.m
  x28c.m
  x29c.m
  x30c.m
  x31c.m
  x33c.m
  plplot_octave_demo.m
  lena.img
  )

if(BUILD_TEST)

  set(full_examples_octave)
  foreach(example ${examples_octave})
    list(APPEND full_examples_octave ${CMAKE_CURRENT_SOURCE_DIR}/${example})
  endforeach(example ${examples_octave})

  if(CORE_BUILD)
    get_property(files_plplot_stub.m_built GLOBAL PROPERTY FILES_plplot_stub.m_built)
    set_property(GLOBAL PROPERTY TARGETS_examples_octave 
      plplot_octave plplot_stub.m_built
      )
    set_property(GLOBAL PROPERTY FILES_examples_octave 
      ${full_examples_octave} ${files_plplot_stub.m_built}
      )
  else(CORE_BUILD)
    # For this case, the (custom) target plplot_stub.m_built and its
    # associated file dependencies, files_plplot_stub.m_built are not
    # defined.  
    set_property(GLOBAL PROPERTY TARGETS_examples_octave 
      plplot_octave
      )
    set_property(GLOBAL PROPERTY FILES_examples_octave 
      ${full_examples_octave}
      )
  endif(CORE_BUILD)
endif(BUILD_TEST)

if(CORE_BUILD)
  install(FILES ${examples_octave} DESTINATION ${DATA_DIR}/examples/octave)

  install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/lena.img
    DESTINATION ${DATA_DIR}/examples
    )
  install(FILES CMakeLists.txt 
    DESTINATION ${DATA_DIR}/examples/octave
    )
endif(CORE_BUILD)

=== tests/wbmp/CMakeLists.txt ===

SET(TESTS_FILES
	wbmp_im2im
	wbmp_null
)

FOREACH(test_name ${TESTS_FILES})
	add_executable(${test_name} "${test_name}.c")
	target_link_libraries (${test_name} gdTest)
	add_test(NAME ${test_name} COMMAND ${test_name})
ENDFOREACH(test_name)

=== bindings/octave/PLplot/CMakeLists.txt ===
# bindings/octave/PLplot/CMakeLists.txt for PLplot
###
### Process this file with cmake to produce Makefile
###
# Copyright (C) 2006 Alan W. Irwin
#
# This file is part of PLplot.
#
# PLplot is free software; you can redistribute it and/or modify
# it under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; version 2 of the License.
#
# PLplot is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General Public License
# along with PLplot; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA

# Install octave support (in support subdirectory), binding "m", and user "m"
# files.

add_subdirectory(support) 

set(binding_m_files
arrow.m
arrows.m
autostyle.m
axis.m
axis_set.m
bgr.m
blue.m
bone.m
bottom_title.m
clip.m
closeallfig.m
closefig.m
colormap.m
comet.m
contour.m
cool.m
copper.m
drawnow.m
fig.m
fig_raise.m
fig_state.m
figure.m
fill.m
free_fig.m
ginput.m
green.m
grid.m
griddata.m
gtext.m
hls2rgb.m
hold.m
hot.m
hsv.m
ishold.m
label_plot.m
legend.m
loglog.m
lp_setup.m
mesh.m
meshc.m
meshz.m
mplot.m
multiplot.m
oneplot.m
peaks.m
pink.m
plclearplot.m
plclg.m
plcolormap.m
pldef.m
plimage.m
plot.m
plot3.m
plot_border.m
plot_margin.m
plrb.m
plsetopt.m
polar.m
prism.m
red.m
rgb2hls.m
rgbplot.m
save_fig.m
semilogx.m
semilogy.m
set_view.m
shade.m
shading.m
shg.m
stopdraw.m
stripc.m
stripc_add.m
stripc_del.m
struct_contains.m
subplot.m
subwindow.m
surf.m
surfc.m
surfl.m
tdeblank.m
text.m
title.m
top_title.m
xlabel.m
xticks.m
ylabel.m
yticks.m
zlabel.m
zoom.m
)
install(FILES ${binding_m_files} DESTINATION ${PLPLOT_OCTAVE_DIR})

configure_file(
${CMAKE_CURRENT_SOURCE_DIR}/plplot_octave_path.m.in
${CMAKE_CURRENT_BINARY_DIR}/plplot_octave_path.m
@ONLY
)
set(user_m_files
use_plplot.m
${CMAKE_CURRENT_BINARY_DIR}/plplot_octave_path.m
toggle_plplot_use.m
)
install(FILES ${user_m_files} DESTINATION ${OCTAVE_M_DIR}/PLplot)

=== cmake/epa_build/fontconfig/CMakeLists.txt ===
# fontconfig/CMakeLists.txt

# Configure the build of fontconfig.

# N.B. this file is generated so if you edit it you will lose all your
# changes the next time it is generated (typically by running
# either/both the update_added_packages.sh or update_pango_packages.sh
# scripts).  If those scripts do not provide good results, then
# consider changing their source files (e.g., by editing the files
# used in those scripts) or add a patch to be run by those scripts.

# Copyright (C) 2013 Alan W. Irwin

# This file is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# This file is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with this file; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

set(PACKAGE fontconfig)

# List of dependencies (most of which are build tools) which should be
# ignored.
set(ignored_dependencies_LIST pkg-config;bison;flex;python2-devel;libX11;libXft;xorg-kbproto;xorg-macros;xorg-xproto;dbus ${extra_ignored_dependencies_list})

set(dependencies_LIST gperf)

# Do boilerplate tasks that must be done for each different project
# that is configured as part of epa_build.
epa_boilerplate(
  ignored_dependencies_LIST
  PACKAGE
  dependencies_LIST
  dependencies_targets
  EPA_PATH
  source_PATH
  ) 

if(MSYS_PLATFORM)
  set(CFLAGS "$ENV{CFLAGS}")
else(MSYS_PLATFORM)
  set(CFLAGS "$ENV{CFLAGS}")
endif(MSYS_PLATFORM)

set(CXXFLAGS "$ENV{CXXFLAGS}")

# Drop -fvisibility=hidden since that option does not work for a
# number of software packages that are configured automatically using
# this template.
string(REGEX REPLACE "-fvisibility=hidden" "" CFLAGS "${CFLAGS}")
string(REGEX REPLACE "-fvisibility=hidden" "" CXXFLAGS "${CXXFLAGS}")

# Data that is related to downloads.
set(URL http://www.freedesktop.org/software/fontconfig/release/fontconfig-2.10.93.tar.bz2)
set(DOWNLOAD_HASH_TYPE SHA256)
set(DOWNLOAD_HASH ea901f278848829ed9937d76fb0ce63ad362d7d5b9e75aa6a6b78bfef42e529c)

ExternalProject_Add(
  build_${PACKAGE}
  DEPENDS ${dependencies_targets}
  URL ${URL}
  URL_HASH ${DOWNLOAD_HASH_TYPE}=${DOWNLOAD_HASH}
  CONFIGURE_COMMAND ${ENV_EXECUTABLE} PATH=${EPA_PATH} "CFLAGS=${CFLAGS}" "CXXFLAGS=${CXXFLAGS}" ${source_PATH}/${EPA_CONFIGURE_COMMAND} --disable-docs
  BUILD_COMMAND ${ENV_EXECUTABLE} PATH=${EPA_PATH} ${EPA_PARALLEL_MAKE_COMMAND} 
  BUILD_IN_SOURCE OFF
  INSTALL_COMMAND ${ENV_EXECUTABLE} PATH=${EPA_PATH} ${EPA_PARALLEL_MAKE_COMMAND}  install
  )

=== cmake/epa_build/freetype_nohb/CMakeLists.txt ===
# freetype_nohb/CMakeLists.txt

# Configure the build of freetype_nohb.

# To follow what is recommended by BLFS, the freetype package (which
# is identical to the current package except for the --with-harfbuzz
# configure option) depends on harfbuzz, which in turn depends on the
# current package which because it uses the --without-harfbuzz
# configure option depends on no other package.

# Copyright (C) 2014 Alan W. Irwin

# This file is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# This file is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with this file; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

set(PACKAGE freetype_nohb)

# List of dependencies (most of which are build tools) which should be
# ignored.
set(ignored_dependencies_LIST ${extra_ignored_dependencies_list})

set(dependencies_LIST)

# Do boilerplate tasks that must be done for each different project
# that is configured as part of epa_build.
epa_boilerplate(
  ignored_dependencies_LIST
  PACKAGE
  dependencies_LIST
  dependencies_targets
  EPA_PATH
  source_PATH
  ) 

set(CFLAGS "$ENV{CFLAGS}")
# Drop -fvisibility=hidden since that option does not work for this package.
string(REGEX REPLACE "-fvisibility=hidden" "" CFLAGS "${CFLAGS}")

# Data that is related to downloads.
set(URL http://downloads.sourceforge.net/freetype/freetype-2.5.3.tar.bz2)
set(DOWNLOAD_HASH_TYPE MD5)
set(DOWNLOAD_HASH d6b60f06bfc046e43ab2a6cbfd171d65)

ExternalProject_Add(
  build_${PACKAGE}
  DEPENDS ${dependencies_targets}
  URL ${URL}
  URL_HASH ${DOWNLOAD_HASH_TYPE}=${DOWNLOAD_HASH}
  CONFIGURE_COMMAND ${ENV_EXECUTABLE} PATH=${EPA_PATH} "CFLAGS=${CFLAGS}" ${source_PATH}/${EPA_CONFIGURE_COMMAND} --without-harfbuzz  --disable-static
  BUILD_COMMAND ${ENV_EXECUTABLE} PATH=${EPA_PATH} ${EPA_PARALLEL_MAKE_COMMAND}
  BUILD_IN_SOURCE 0
  INSTALL_COMMAND ${ENV_EXECUTABLE} PATH=${EPA_PATH}  ${EPA_PARALLEL_MAKE_COMMAND} install
  )

# Note BLFS recommends the extra steps of installing the
# documentation, enabling GX/AAT and OpenType table validation, and
# enabling Subpixel Rendering and Subpixel Hinting in order to improve
# font rendering.  However, for simplicity we do none of those extra
# steps for now (which also renders moot the possibility [discussed in
# detail by BLFS] that Subpixel Rendering _might_ be patent
# encumbered).

=== cmake/epa_build/gtk+/CMakeLists.txt ===
# gtk+/CMakeLists.txt

# Configure the build of gtk+.

# N.B. this file is generated so if you edit it you will lose all your
# changes the next time it is generated (typically by running
# either/both the update_added_packages.sh or update_pango_packages.sh
# scripts).  If those scripts do not provide good results, then
# consider changing their source files (e.g., by editing the files
# used in those scripts) or add a patch to be run by those scripts.

# Copyright (C) 2013 Alan W. Irwin

# This file is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# This file is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with this file; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

set(PACKAGE gtk+)

# List of dependencies (most of which are build tools) which should be
# ignored.
set(ignored_dependencies_LIST pkg-config;bison;flex;python2-devel;libX11;libXft;xorg-kbproto;xorg-macros;xorg-xproto;dbus ${extra_ignored_dependencies_list})

set(dependencies_LIST at-spi2-atk;atk;cairo;gdk-pixbuf;glib;gobject-introspection;gtk-doc;libxkbcommon;pango)

# Do boilerplate tasks that must be done for each different project
# that is configured as part of epa_build.
epa_boilerplate(
  ignored_dependencies_LIST
  PACKAGE
  dependencies_LIST
  dependencies_targets
  EPA_PATH
  source_PATH
  ) 

if(MSYS_PLATFORM)
  set(CFLAGS "$ENV{CFLAGS}")
else(MSYS_PLATFORM)
  set(CFLAGS "$ENV{CFLAGS}")
endif(MSYS_PLATFORM)

set(CXXFLAGS "$ENV{CXXFLAGS}")

# Drop -fvisibility=hidden since that option does not work for a
# number of software packages that are configured automatically using
# this template.
string(REGEX REPLACE "-fvisibility=hidden" "" CFLAGS "${CFLAGS}")
string(REGEX REPLACE "-fvisibility=hidden" "" CXXFLAGS "${CXXFLAGS}")

# Data that is related to downloads.
set(URL http://download.gnome.org/sources/gtk+/3.9/gtk+-3.9.8.tar.xz)
set(DOWNLOAD_HASH_TYPE SHA256)
set(DOWNLOAD_HASH a2053a9556c600e0217ec48df75e96aad909f3bc4ec307d2e04817ac548d39a8)

ExternalProject_Add(
  build_${PACKAGE}
  DEPENDS ${dependencies_targets}
  URL ${URL}
  URL_HASH ${DOWNLOAD_HASH_TYPE}=${DOWNLOAD_HASH}
  CONFIGURE_COMMAND ${ENV_EXECUTABLE} PATH=${EPA_PATH} "CFLAGS=${CFLAGS}" "CXXFLAGS=${CXXFLAGS}" ${source_PATH}/${EPA_CONFIGURE_COMMAND} --enable-x11-backend
  BUILD_COMMAND ${ENV_EXECUTABLE} PATH=${EPA_PATH} ${EPA_PARALLEL_MAKE_COMMAND} 
  BUILD_IN_SOURCE OFF
  INSTALL_COMMAND ${ENV_EXECUTABLE} PATH=${EPA_PATH} ${EPA_PARALLEL_MAKE_COMMAND}  install
  )

=== cmake/epa_build/iwidgets/CMakeLists.txt ===
# iwidgets/CMakeLists.txt

# Configure the build of iwidgets.

# Copyright (C) 2013 Alan W. Irwin

# This file is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# This file is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with this file; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

set(PACKAGE iwidgets)

# List of dependencies (most of which are build tools) which should be
# ignored.
set(ignored_dependencies_LIST ${extra_ignored_dependencies_list})

set(dependencies_LIST itk tk tcl)

# Do boilerplate tasks that must be done for each different project
# that is configured as part of epa_build.
epa_boilerplate(
  ignored_dependencies_LIST
  PACKAGE
  dependencies_LIST
  dependencies_targets
  EPA_PATH
  source_PATH
  )

set(VERSION 4.1.0)
set(OLD_VERSION 4.0.1)
set(LIBVERSION 4.1)
set(CMAKE_OPTION -DBUILD_IWIDGETS_4.1=ON)

# Data that is related to downloads.
set(URL http://downloads.sourceforge.net/project/incrtcl/%5bIncr%20Widgets%5d/${OLD_VERSION}/iwidgets${OLD_VERSION}.tar.gz)
set(DOWNLOAD_HASH_TYPE MD5)
set(DOWNLOAD_HASH 0e9c140e81ea6015b56130127c7deb03)

ExternalProject_Add(
  build_${PACKAGE}
  DEPENDS ${dependencies_targets}
  URL ${URL}
  URL_HASH ${DOWNLOAD_HASH_TYPE}=${DOWNLOAD_HASH}
  PATCH_COMMAND ""
  CONFIGURE_COMMAND ${ENV_EXECUTABLE} PATH=${EPA_PATH} ${EPA_CMAKE_COMMAND} ${CMAKE_OPTION} ${EPA_BASE}/Source/build_${PACKAGE}
  BUILD_COMMAND ${ENV_EXECUTABLE} PATH=${EPA_PATH} ${EPA_PARALLEL_BUILD_COMMAND}
  INSTALL_COMMAND ${ENV_EXECUTABLE} PATH=${EPA_PATH} ${EPA_PARALLEL_BUILD_COMMAND} install
  )
# For this (4.1) case we do not use the
# http://downloads.sourceforge.net/project/kbskit/itk/iwidgets41.tar.gz
# tarball because there are some problems (incorrect install
# locations and only a subset of what is normally installed) for
# that binary distribution of iwidgets4.1.  Instead, we build 4.1
# similarly to 4.0 except we apply the following patch which was
# derived as follows:
#
# diff -Naur iwidgets4.0.1/README iwidgets4.1/README >iwidgets4.1.patch
# diff -Naur iwidgets4.0.1/license.terms iwidgets4.1/license.terms >>iwidgets4.1.patch
# diff -Naur --exclude=pkgIndex.tcl iwidgets4.0.1/generic iwidgets4.1/library >> iwidgets4.1.patch 
# diff -Naur iwidgets4.0.1/tests iwidgets4.1/tests >> iwidgets4.1.patch
#
# N.B. this patch is somewhat larger than
# iwidgets4.1/iwidgets.patch because that latter patch is only
# concerned with generic subdirectory differences and it also
# appears to be taken against iwidgets-4.0.2 (which I cannot find
# anywhere on the net) rather than iwidgets-4.0.1.
add_custom_command(
  OUTPUT
  ${EPA_BASE}/Stamp/build_${PACKAGE}/build_${PACKAGE}-patch
  COMMAND echo "Apply iwidgets4.1 source code patch"
  COMMAND ${PATCH_EXECUTABLE} --directory=${EPA_BASE}/Source/build_${PACKAGE} -p1 < ${CMAKE_CURRENT_SOURCE_DIR}/${PACKAGE}4.1.patch
  COMMAND echo "Apply patch to support both iwidgets and Iwidgets package names"
  COMMAND ${PATCH_EXECUTABLE} --directory=${EPA_BASE}/Source/build_${PACKAGE} -p1 < ${CMAKE_CURRENT_SOURCE_DIR}/${PACKAGE}4_case.patch
  APPEND
  )

add_custom_command(
  OUTPUT
  ${EPA_BASE}/Stamp/build_${PACKAGE}/build_${PACKAGE}-patch
  COMMAND echo "Add CMake-based build system"
  COMMAND ${CMAKE_COMMAND} -E copy_if_different 
  ${CMAKE_CURRENT_SOURCE_DIR}/${PACKAGE}_CMakeLists.txt
  ${EPA_BASE}/Source/build_${PACKAGE}/CMakeLists.txt
  APPEND
  )

=== debian/changelog ===
pftools (3.2.11-2) unstable; urgency=medium

  * Team Upload.
  * Revert "Add missing build dependency on dh addon."
  * Add patch to fix blhc
  * d/salsa-ci.yml:
    + Disable i386 build
    + Disable reprotest

 -- Nilesh Patra <nilesh@debian.org>  Tue, 25 Jan 2022 22:35:45 +0530

pftools (3.2.11-1) unstable; urgency=medium

  * Use Github tags instead of releases
  * New upstream version

 -- Andreas Tille <tille@debian.org>  Tue, 25 Jan 2022 10:01:51 +0100

pftools (3.2.8-1) unstable; urgency=medium

  * Team Upload.
  [ Steffen Moeller ]
  * Fix watchfile to detect new versions on github (routine-update)

  [ Andreas Tille ]
  * New upstream version
  * Standards-Version: 4.6.0 (routine-update)
  * Drop patch applied upstream

  [ Nilesh Patra ]
  * d/rules:
    + Build without regex support
    + Remove test.sh command manual run
    + Install examples at right location
  * d/control: Remove B-D on libpcre2-dev (Closes: #1000002)
  * Tweak autopkgtest to get it working

 -- Nilesh Patra <nilesh@debian.org>  Tue, 25 Jan 2022 01:49:00 +0530

=== debian/control ===
Source: pftools
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               gfortran,
               cmake,
               libfile-slurp-perl,
               libbz2-dev,
               libreadline-dev,
               zlib1g-dev
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/med-team/pftools
Vcs-Git: https://salsa.debian.org/med-team/pftools.git
Homepage: https://github.com/sib-swiss/pftools3
Rules-Requires-Root: no

Package: pftools
Architecture: any-amd64
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libfile-slurp-perl
Description: build and search protein and DNA generalized profiles
 The pftools package contains all the software necessary to build protein
 and DNA generalized profiles and use them to scan and align sequences,
 and search databases.
 .
 File formats used by the pftools
  * Generalized profiles format and syntax.
  * The multiple sequence alignment format (PSA).
  * The extended header multiple sequence alignment format (XPSA).
 .
 Programs to build generalized profiles
  pfmake
    Build a profile from a multiple sequence alignment.
  pfscale
    Fit parameters of an extreme-value distribution to a profile score list.
  pfw
    Weight sequences of a multiple sequence alignment to correct for
    sampling bias.
 .
 Programs to search with generalized profiles
  pfsearch / pfsearchV3
    Search a protein or DNA sequence library for sequence segments matching
    a profile (V3 is the new version of this tool).
  pfscan
    Scan a protein or DNA sequence with a profile library
 .
 Conversion programs
  psa2msa
    Reformat PSA file to Pearson/Fasta multiple sequence alignment file.
  ptof
    Convert a protein profile into a frame-search profile to search DNA
    sequences. To be used with 2ft.
  2ft
    Converts both strands of DNA into so-called interleaved
    frame-translated DNA sequences to search with protein profiles. To be
    used with ptof.
  6ft
    Translates all six reading frames of a double-stranded DNA sequence
    into individual protein sequences.
  pfgtop
    Convert a profile in GCG format into PROSITE format.
  pfhtop
    Convert a HMMER1 ASCII-formatted HMM into an equivalent PROSITE profile.
  ptoh
    Converts a generalized profile into an approximately equivalent HMM
    profile in HMMER1 format (can be read by the hmmconvert program from
    the HMMER2 package).

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

include /usr/share/dpkg/default.mk

%:
	dh $@

override_dh_auto_configure:
	if [ ! -e src/C/config.h.cmake ] ; then cp -a debian/missing-sources/config.h.cmake src/C/ ; fi
	dh_auto_configure -- -DUSE_PCRE=OFF

override_dh_auto_install:
	dh_auto_install
	# Avoid name spacing conflict with htop and consequently also rename gtop
	mv debian/$(DEB_SOURCE)/usr/bin/gtop debian/$(DEB_SOURCE)/usr/bin/pfgtop
	mv debian/$(DEB_SOURCE)/usr/bin/htop debian/$(DEB_SOURCE)/usr/bin/pfhtop

override_dh_installexamples:
	dh_installexamples
	cp -a debian/pftools/usr/share/examples/* debian/pftools/usr/share/doc/pftools/examples/
	rm -rf debian/pftools/usr/share/data/ debian/pftools/usr/share/examples/

override_dh_installman:
	dh_installman
	mv debian/$(DEB_SOURCE)/usr/share/man/man1/gtop.1 debian/$(DEB_SOURCE)/usr/share/man/man1/pfgtop.1
	mv debian/$(DEB_SOURCE)/usr/share/man/man1/htop.1 debian/$(DEB_SOURCE)/usr/share/man/man1/pfhtop.1
	mv debian/$(DEB_SOURCE)/usr/share/doc/*.pdf debian/$(DEB_SOURCE)/usr/share/doc/${DEB_SOURCE}/
	rm -f debian/$(DEB_SOURCE)/usr/share/doc/*.txt debian/${DEB_SOURCE}/usr/ChangeLog debian/${DEB_SOURCE}/usr/README* debian/${DEB_SOURCE}/usr/LICENSE

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_test --no-parallel
endif

override_dh_auto_clean:
	dh_auto_clean
	rm -rf data/test.*
